#include <stdint.h>

#define HQT(rule, fa, tr) ( (rule) | ((tr) << 12) | ((fa) << 8) )
#define HQT_12 HQT(12,  4, 0)
#define HQT_13 HQT(12, 10, 0)
#define HQT_14 HQT(12, 11, 0)
#define HQT_15 HQT(12,  4, 1)
#define HQT_16 HQT(12,  9, 1)
#define HQT_17 HQT(12, 10, 1)
#define HQT_18 HQT(13,  7, 2)
#define HQT_19 HQT(14,  8, 3)
const static uint16_t hqTable1[256] = { // table for upper left corner
  4, 4, 6,      2, 4, 4, 6,      2, 5,      3, HQT_15, HQT_12, 5,      3, HQT_17, HQT_13,
  4, 4, 6, HQT_18, 4, 4, 6, HQT_18, 5,      3, HQT_12, HQT_12, 5,      3,      1, HQT_12,
  4, 4, 6,      2, 4, 4, 6,      2, 5,      3, HQT_17, HQT_13, 5,      3, HQT_16, HQT_14,
  4, 4, 6, HQT_18, 4, 4, 6, HQT_18, 5,      3, HQT_16, HQT_12, 5,      3,      1, HQT_14,
  4, 4, 6,      2, 4, 4, 6,      2, 5, HQT_19, HQT_12, HQT_12, 5, HQT_19, HQT_16, HQT_12,
  4, 4, 6,      2, 4, 4, 6,      2, 5,      3, HQT_16, HQT_12, 5,      3, HQT_16, HQT_12,
  4, 4, 6,      2, 4, 4, 6,      2, 5, HQT_19,      1, HQT_12, 5, HQT_19,      1, HQT_14,
  4, 4, 6,      2, 4, 4, 6, HQT_18, 5,      3, HQT_16, HQT_12, 5, HQT_19,      1, HQT_14,
  4, 4, 6,      2, 4, 4, 6,      2, 5,      3, HQT_15, HQT_12, 5,      3, HQT_17, HQT_13,
  4, 4, 6,      2, 4, 4, 6,      2, 5,      3, HQT_16, HQT_12, 5,      3, HQT_16, HQT_12,
  4, 4, 6,      2, 4, 4, 6,      2, 5,      3, HQT_17, HQT_13, 5,      3, HQT_16, HQT_14,
  4, 4, 6,      2, 4, 4, 6,      2, 5,      3, HQT_16, HQT_13, 5,      3,      1, HQT_14,
  4, 4, 6,      2, 4, 4, 6,      2, 5,      3, HQT_16, HQT_12, 5,      3, HQT_16, HQT_13,
  4, 4, 6,      2, 4, 4, 6,      2, 5,      3, HQT_16, HQT_12, 5,      3,      1, HQT_12,
  4, 4, 6,      2, 4, 4, 6,      2, 5,      3, HQT_16, HQT_12, 5,      3,      1, HQT_14,
  4, 4, 6,      2, 4, 4, 6,      2, 5,      3,      1, HQT_12, 5,      3,      1, HQT_14,
};

const static uint16_t hqTable2[256] = { // table for upper right corner
  4, 4,      5,      5,      4,      4,      3,      3, 4, 4,      5,      5, 4,      4, HQT_19, HQT_19,
  6, 6, HQT_15, HQT_17,      2,      2, HQT_12, HQT_13, 6, 6, HQT_12,      1, 2,      2, HQT_12, HQT_12,
  4, 4,      5,      5,      4,      4,      3,      3, 4, 4,      5,      5, 4,      4,      3,      3,
  6, 6, HQT_15, HQT_17,      2,      2, HQT_12, HQT_13, 6, 6, HQT_16, HQT_16, 2,      2, HQT_12, HQT_12,
  4, 4,      5,      5,      4,      4,      3,      3, 4, 4,      5,      5, 4,      4,      3,      3,
  6, 6, HQT_12, HQT_16, HQT_18, HQT_18, HQT_12, HQT_12, 6, 6, HQT_16, HQT_16, 2,      2, HQT_12, HQT_12,
  4, 4,      5,      5,      4,      4,      3,      3, 4, 4,      5,      5, 4,      4,      3,      3,
  6, 6, HQT_16, HQT_16,      2,      2, HQT_12, HQT_13, 6, 6, HQT_16,      1, 2,      2, HQT_12, HQT_12,
  4, 4,      5,      5,      4,      4,      3,      3, 4, 4,      5,      5, 4,      4, HQT_19, HQT_19,
  6, 6, HQT_17, HQT_16,      2,      2, HQT_13, HQT_14, 6, 6, HQT_16,      1, 2,      2, HQT_12, HQT_14,
  4, 4,      5,      5,      4,      4,      3,      3, 4, 4,      5,      5, 4,      4,      3,      3,
  6, 6, HQT_17, HQT_16,      2,      2, HQT_13, HQT_14, 6, 6, HQT_16,      1, 2,      2, HQT_13, HQT_14,
  4, 4,      5,      5,      4,      4,      3,      3, 4, 4,      5,      5, 4,      4,      3, HQT_19,
  6, 6,      1,      1, HQT_18, HQT_18, HQT_12, HQT_14, 6, 6, HQT_16,      1, 2, HQT_18, HQT_12, HQT_14,
  4, 4,      5,      5,      4,      4,      3,      3, 4, 4,      5,      5, 4,      4,      3,      3,
  6, 6, HQT_16,      1,      2,      2, HQT_12, HQT_14, 6, 6,      1,      1, 2,      2, HQT_12, HQT_14,
};

const static uint16_t hqTable3[256] = { // table for lower right corner
       4,      4,      4,      4,      4,      4,      4,      4,      4,      4,      4,      4,      4,      4,      4,      4,
       5,      5,      5,      5,      5,      5,      5,      5,      5,      5,      5,      5,      5,      5,      5,      5,
       4,      4,      4,      4,      4,      4,      4,      4,      4,      4,      4,      4,      4,      4,      4,      4,
       5,      5,      5,      5,      5,      5,      5,      5,      5,      5,      5,      5,      5,      5,      5,      5,
       6,      6,      6,      6,      6,      6,      6,      6,      6,      6,      6,      6,      6,      6,      6,      6,
  HQT_15, HQT_15, HQT_12, HQT_16, HQT_17, HQT_17,      1, HQT_16, HQT_12, HQT_16, HQT_16, HQT_16, HQT_16, HQT_16, HQT_16,      1,
       6,      6,      6,      6,      6,      6,      6,      6,      6,      6,      6,      6,      6,      6,      6,      6,
  HQT_17, HQT_17, HQT_16, HQT_16, HQT_16, HQT_16,      1,      1,      1, HQT_16, HQT_16,      1,      1,      1,      1,      1,
       4,      4,      4,      4,      4,      4,      4,      4,      4,      4,      4,      4,      4,      4,      4,      4,
       3,      3, HQT_19,      3,      3,      3, HQT_19,      3,      3,      3,      3,      3,      3,      3,      3,      3,
       4,      4,      4,      4,      4,      4,      4,      4,      4,      4,      4,      4,      4,      4,      4,      4,
       3,      3, HQT_19,      3,      3,      3, HQT_19,      3,      3,      3,      3,      3,      3,      3, HQT_19,      3,
       2,      2,      2,      2,      2,      2,      2,      2, HQT_18,      2,      2,      2, HQT_18,      2,      2,      2,
  HQT_12, HQT_12, HQT_12, HQT_12, HQT_13, HQT_13, HQT_12, HQT_12, HQT_12, HQT_12, HQT_12, HQT_12, HQT_12, HQT_13, HQT_12, HQT_12,
       2,      2,      2,      2,      2,      2,      2,      2, HQT_18,      2,      2,      2, HQT_18,      2, HQT_18,      2,
  HQT_13, HQT_13, HQT_12, HQT_13, HQT_14, HQT_14, HQT_14, HQT_14, HQT_12, HQT_12, HQT_12, HQT_12, HQT_14, HQT_14, HQT_14, HQT_14,
};

const static uint16_t hqTable4[256] = { // table for lower left corner
       4,      4, 4,      4, 4, 4, 4, 4,      6,      6,      6,      6,      6,      6,      6,      6,
       4,      4, 4,      4, 4, 4, 4, 4,      6,      6,      6,      6,      6,      6,      6,      6,
       4,      4, 4,      4, 4, 4, 4, 4,      2,      2, HQT_18, HQT_18,      2,      2,      2,      2,
       4,      4, 4,      4, 4, 4, 4, 4,      2,      2,      2,      2,      2,      2,      2,      2,
       5,      5, 5,      5, 5, 5, 5, 5, HQT_15, HQT_17, HQT_12,      1, HQT_15, HQT_17, HQT_16, HQT_16,
       5,      5, 5,      5, 5, 5, 5, 5, HQT_12, HQT_16, HQT_16, HQT_16, HQT_16, HQT_16, HQT_16,      1,
       3,      3, 3,      3, 3, 3, 3, 3, HQT_12, HQT_13, HQT_12, HQT_12, HQT_12, HQT_13, HQT_12, HQT_12,
  HQT_19, HQT_19, 3,      3, 3, 3, 3, 3, HQT_12, HQT_12, HQT_12, HQT_12, HQT_12, HQT_13, HQT_12, HQT_12,
       4,      4, 4,      4, 4, 4, 4, 4,      6,      6,      6,      6,      6,      6,      6,      6,
       4,      4, 4,      4, 4, 4, 4, 4,      6,      6,      6,      6,      6,      6,      6,      6,
       4,      4, 4,      4, 4, 4, 4, 4,      2,      2, HQT_18, HQT_18,      2,      2,      2,      2,
       4,      4, 4,      4, 4, 4, 4, 4,      2,      2,      2, HQT_18,      2,      2,      2,      2,
       5,      5, 5,      5, 5, 5, 5, 5, HQT_17, HQT_16, HQT_16,      1, HQT_17, HQT_16, HQT_16,      1,
       5,      5, 5,      5, 5, 5, 5, 5,      1,      1, HQT_16,      1, HQT_16,      1,      1,      1,
       3,      3, 3,      3, 3, 3, 3, 3, HQT_13, HQT_14, HQT_12, HQT_14, HQT_13, HQT_14, HQT_13, HQT_14,
  HQT_19, HQT_19, 3, HQT_19, 3, 3, 3, 3, HQT_12, HQT_14, HQT_12, HQT_14, HQT_12, HQT_14, HQT_12, HQT_14,
};

void hq2x_init(uint16_t *hqTable) {
    int i;
    for (i = 0; i < 256; i++) {
        hqTable[i] = hqTable1[i];
    }
    for (i = 0; i < 256; i++) {
        hqTable[i+256] = hqTable2[i];
    }
    for (i = 0; i < 256; i++) {
        hqTable[i+512] = hqTable3[i];
    }
    for (i = 0; i < 256; i++) {
        hqTable[i+768] = hqTable4[i];
    }
}

